
Game = Core.class(Sprite)

function Game:init()
  game = SELF -- make game class global (available to all other class instances)

  self:startUp() -- initialize stuff
  
  self:addEventListener("enterBegin", self.onTransitionInBegin, self)
  self:addEventListener("enterEnd", self.onTransitionInEnd, self)
  self:addEventListener("exitBegin", self.onTransitionOutBegin, self)
  self:addEventListener("exitEnd", self.onTransitionOutEnd, self)
end

function Game:onTransitionInBegin() -- INITIALIZE VARIABLES HERE
end

function Game:onTransitionInEnd() -- ADD LISTENERS, START LOGIC
  self:addEventListener(Event.ENTER_FRAME, self.update, self)
end

function Game:onTransitionOutBegin() -- STOP TIMERS, REMOVE LISTENERS
  self:removeEventListener(Event.ENTER_FRAME, self.update, self)
end

function Game:onTransitionOutEnd() -- GONE FROM STAGE, CLEANUP
  self:removeEventListener("enterBegin", self.onTransitionInBegin, self)
  self:removeEventListener("enterEnd", self.onTransitionInEnd, self)
  self:removeEventListener("exitBegin", self.onTransitionOutBegin, self)
  self:removeEventListener("exitEnd", self.onTransitionOutEnd, self)
end

function Game:startUp()
end

function Game:update(event) -- CALLED EVERY FRAME
  local dt = event.deltaTime

  application:setBackgroundColor(0x44ff88)
end
